/* 11 avr 2011 .. 
******************
  a suivre ...
****************









    PIC18F252 avec  MPLAB IDE V8.60   C18 version complete 13j (...was 60j)
    projet:		C:\Mplab8\C18\_MesProjets\IRC5_18F252.mcp
    source:		C:\Mplab8\C18\_MesProjets\IRC5_18F252_0411.c
    chargeur :	C:\Mplab8\C18\_MesProjets\IRC5_18F252_0411.hex
    docu : 		E:\C18\doc\MPLAB_ C18_librairies_51297c.pdf
                  cours PIC18Fxx2.pdf
    Soft UART Hardware 19200 bauds
    /* =========== HARDWARE ====================
PIC 18F252  microchip  avec Bootoader install en fond de memoire
27 pf  Q=10Mhz 27pF

Interface 2T pour liaison UART TTL <-> RS232 19200 bauds
PortB
B0  21  Input TSOP1736  info I.R  avec led en //  tiree au +5V via 2.7K
B1  22  Led Blanche.
B2  23  
B3  24 
B4  25 
B5  26 

B6  27  
B7  28  
B6  27 
B7  28 

PORTA
A0   2  Ana CH0
A1   3  Ana CH1
A2   4  Ana CH2
A3   5  Ana CH3
A4   6  R + Led rouge
A5   7  Ana CH4

PORTC
C6   17  TX  RS232
C7   18  RX  RS232

1 potar 10T sur entree Ana CH0 PIC18F

*/

#include <p18f252.h>   /* for TRISB and PORTB declarations */

#include <delays.h>    /* for delay routines */
#include <stdlib.h>
#include <delays.h>
#include <string.h>
#include <adc.h>
#include <portb.h>
#include <timers.h>

//config du PIC
#pragma config OSC = HS
#pragma config PWRT = ON
#pragma config WDT = OFF
#pragma config BOR = OFF
#pragma config BORV = 42
#pragma config LVP = OFF

#define Byte unsigned char 
#define CLS 8
#define TAB 9
#define CR 13
#define LF 10
#define Bell 7
#define ON 0	// logique inverse avec led tiree au +5V
#define OFF 1

#define LedRouge   PORTAbits.RA4
#define IR_signal  PORTBbits.RB0
#define LedBlanc  PORTBbits.RB1

#define SIZE	40		/* taille buffer */
#define TDRE	0x80

rom const char chaine1[]="Port comm 19200 ouvert";
rom const char chaine2[]=".................";
rom const char chaine3[]="ESC pour sortir\r";
rom const char chaine4[]="..................\r";
rom const char chaine5[]="Sortie Normale de Prg";
rom const char chaine6[]="car recu :";
rom const char chaine7[]="Init 1............\r";
rom const char chaine8[]="Init 2............\r";
rom const char chaine9[]="Init ADC10b PIC18F\r";
rom const char chaine10[]=".................\r";
rom const char chaine11[]=".................\r";
rom const char chaine12[]="IR TSOP Capture= \r";
rom const char chaine13[]="C18: IRC5_18F252_0411.c\r";

rom char *Menu_Str[]={chaine1,chaine2,chaine3,chaine4,chaine5,chaine6,chaine7,
                        chaine8,chaine9,chaine10,chaine11,chaine12,chaine13,};

#pragma romdata EEP_=0xF00000

      rom unsigned char EEPROM_data [][32] ={
      //   1234567890123456789012345678901
          "Port Com 19200b & Init HARD....",//0   avec terminateur zero
          "................  <ESC> exit   ",//20  avec terminateur zero
          ".............................. ",//40  avec terminateur zero
          "Usage I2c Software MPLAB C18  \r",//60
          "18F252 avec bootloader        \r", //80  sans terminateur
          "paulfjujo@free.fr             \r", //A0  sans terminateur
          "MPLAB IDE V8.63.............. \r", //C0  sans terminateur
          "MPLAB C18 v3.37.01 .........\r\n"  //D0 avec terminateur zero
          };
#pragma romdata 
         
/*	Variables globales */
char Texte[64]="PROJET: IRC5_18F252.mcp \r";
char *txt=&Texte[0];
unsigned char Entree[16]="123456789012345";
unsigned char *valtxt;
char buffer[SIZE+1]="1234567890123456";	/* buffer de reception */
char *ptlec;		/* pointeur de lecture */
char *ptecr;		/* pointeur d'criture */
Byte Drapeau;
Byte receive;
char error;
char EtatCf;
signed char Ve;
unsigned int  NbMes;
Byte Allume_led;
Byte Dummy;
unsigned short int i,j,k;
unsigned char s_count = 0;
unsigned int M,M1;	
// mesure ADC 18 bits
unsigned long ML=0L ;   
struct ForByte 
{
	near unsigned char pv0;
	near unsigned char pv1;
	near unsigned char pv2;
	near unsigned char pv3;
	} pV;
	
union {
	near unsigned long ML;
	near struct ForByte pV;
	} MV;	
	
// IRC5
unsigned int adr, comm;
unsigned int  togg, count;
Byte RC5Len;

//---- declaration des sub ----------------

//---- EEPROM PIC
unsigned char EEPROM_Lect(unsigned char adrL) ; // lecture a l'adresse adrL
void EEPROM_Ecr(unsigned char adrE,unsigned char car); // ecrit  a l'adresse adrE
void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(int PtrE);

////--- local Softw RS232 ------
void Init_RS(void);
void Put_RS(unsigned char c);
unsigned char Get_RS(void);
char *GetStr_RS(char *s, char finst);
int PutStr_RS(char *s);

//---- Other subroutines
void Init_Hardware(void) ;
void Tempo(long int value);
void Idle(void);
void Octet2Hex(unsigned char number);
void Decompile_byte(Byte un);
void Write_Word(unsigned int M);
void CRLF(void);

//----- ADC 10 b
void OpenADC( unsigned char config,unsigned char config2 );
void SetChanADC( unsigned char channel );
char BusyADC( void );		// 1= busy
void ConvertADC( void );
int ReadADC( void );
void CloseADC( void );

//--- interrupts
void timer0_Rb0_ISR (void);
void Serial_ISR(void);

//------------  SUBROUTINES IRC5  -----------------------
Byte check_start_byte(Byte status) ;
Byte check_start_byte(Byte status) ;
unsigned short read_rc5(short *toggle, short *adress, short *command);

/*
 TSOP1736 aliment en +5V filtre 82ohms 10F tantale 
 Sortie du TSOP -> entree RB0. usage del'interrupt RB0et du timer0. 
 Prescaler Timer0 a ajuster en fionction de l'horloge Quartz  ici Q=10Mhz
 => 1 cycle en 0.25S
*/

unsigned short check_byte() { // check if its logic 0 or logic 1

     unsigned short old;
     //1 bit en 888S   soit 2222 cycles at 10Mhz  * 3/4=1481 cycles
     Delay10TCYx(148); // delay 3/4 full time so after that we are in the
     old = PORTBbits.RB0; // 1/4 part of first byte, and we reading data

      WriteTimer0( 0 ); ;
     INTCONbits.T0IF = 0; // prepare timer0 to count
     // wait until tsop will give us another signal than we saved in old
     // and check if that didnt take too long or too short
     // and compare that with rc5len that we calculated in rc5_init
     // and if its not good then return 127, else return old value
     // rclen should be equal to 432us (depend on sendind signal)
     while (PORTBbits.RB0 == old) {
           if (ReadTimer0() > (RC5Len + 10)) return 127;
     }
     if (ReadTimer0()< (RC5Len - 10)) return 127;
     return old;

}

Byte check_start_byte(Byte status) 
 {
     // here everything is the same like before but we dont wait 3/4 full
     // byte time,but just we waiting forlogic 1 or 0 (defined by status)
     // so its 1/2 of byte
     WriteTimer0(0);  
     INTCONbits.T0IF = 0;
     while (PORTBbits.RB0 == status) {
           if (ReadTimer0() > ((RC5Len * 2) + 10)) return 127;
     }
     if (  ReadTimer0() < ((RC5Len * 2) - 10)) return 127;
     // again read tmr0 and check if it wast tooshort or too long
     return 1;
}

unsigned short read_rc5(short *toggle, short *adress, short *command)
{
     // its main function of reading rc5 code
        short tmp;
        short i1;
        *toggle  = 0;
        *adress  = 0;
        *command = 0;
        // here we checking our 2 start bytes, we just wait if tsop will make
        // falling or rising edge (its defined by status, 0 or 1);
        tmp = check_start_byte(0);
        if (tmp == 127) goto err1;
        tmp = check_start_byte(1);
        if (tmp == 127) goto err1;
        // and we reading toggle byte (dont forget about 127 for error)
        tmp = check_byte();
        if (tmp == 127) goto err1;
        if (tmp) *toggle = 1;
        // read adress and check for errors
        for (i1 = 0; i1 <= 4; i1++) {
            tmp = check_byte();
            if (tmp == 127) goto err1;
            if (tmp) *adress = *adress | (1<<i1);
        }
        // read command and check for errors
        for (i1 = 0; i1 <= 5; i1++) {
            tmp = check_byte();
            if (tmp == 127) goto err1;
            if (tmp) *command = *command | (1<<i1);
        }
        err1:         // and that will be done always, no matter for errors
         INTCONbits.T0IF = 0;
        if (tmp == 127) return 1; // if error then rc5_read = 1
        else return 0;
}

unsigned int rc5_init(void)
 {     
    // OpenRB0INT( PORTB_CHANGE_INT_ON & FALLING_EDGE_INT & PORTB_PULLUPS_ON);
     OpenTimer0(TIMER_INT_ON & T0_16BIT & T0_SOURCE_INT & T0_PS_1_4);
     //INTCONbits.GIE = 1;
     //INTCONbits.PEIE = 1;
     //WriteTimer0(0);     
     //1 bit en 888S   soit 2222 cycles at 10Mhz  * 1/2 =1111 cycles
     Delay10TCYx(111); 
     return ReadTimer0()-2;    // during 1/2 byte time, 432 us
}


//--------- RS232 local software --------------

/* initialise les communications */
void Init_RS(void)
{
    TRISCbits.TRISC7 = 1;  // RX - Set Recieve pin for tristate
    TRISCbits.TRISC6 = 0;  // TX - Set as Output
    SPBRG = 32; 	         // configure la vitesse (BAUD) 19200 Q=10Mhz 
    //SPBRG = 64;          // configure la vitesse (BAUD) 9600  Q=10Mhz 
    // TXSTA = 0x24;					/* TXEN=1  BRGH=1
    TXSTAbits.TXEN = 1;    // transmit enabled
    TXSTAbits.BRGH = 1;    // high data rate for sending
    TXSTAbits.TX9 = 0;     // 8-bit transmission
    //  RCSTA = 0x90;      // active l'USART  SPEN=1  et   CREN=1  
    RCSTAbits.SPEN = 1;    // enable serial port pins RX et TX port B
    RCSTAbits.CREN = 1;    // enable asynchrone Continuous Receiver ENable bit 
    PIR1bits.TXIF=0;	   // IT en emission desactivee
    PIE1bits.RCIE=1;	   // IT en reception activee
    INTCONbits.GIEH=1;     //autorise les IT 
    INTCONbits.GIEL=1;
}

unsigned char Get_RS(void)
	{
	unsigned char c;
	while (ptlec == ptecr);
	c = *ptlec++;
	if (ptlec >= &buffer[SIZE])	ptlec = buffer;
	return (c);
	}

/*	emission d'un caractere */
void Put_RS(unsigned char c)
{
    while(!TXSTAbits.TRMT);
    TXREG=c;                           /* envoie un caractre */
    while(!PIR1bits.TXIF);
	}

/* retourne une chaine de caractere*/
char *GetStr_RS(char *s, char Terminator)
{
	char *r = s;
	char c;
	while ((c = Get_RS()) != Terminator)*s++ = c;
	*s = 0;
	return r;
}

/* envoie une chaine de caractere*/
int PutStr_RS(char *s)
{
	int n;
	for (n = 0; *s; n++, s++) Put_RS(*s);
//	Put_RS('\n');
	return 1;
}


// ---- init  interruptions ------------------------

// Serial Interrupt 
#pragma code highvector=0x0008
void interrupt_at_high_vector(void)
{
_asm   goto Serial_ISR   _endasm
}
#pragma code

#pragma interrupt Serial_ISR
void Serial_ISR(void)				// reception d'une interruption
{char c;
	if(PIR1bits.RCIF)		/* detection IT USART en reception*/
	{
	c=RCREG;
	*ptecr++ = c;
	if (ptecr >= &buffer[SIZE]) ptecr = buffer;
	PIR1bits.RCIF=0;
	}
}

//--------  Timer0 interrupt 
#pragma code lowVector=0x0018
 void interrupt_at_low_vector (void)
 {
 _asm 
 goto timer0_Rb0_ISR 
 _endasm
 }
#pragma code

#pragma interrupt timer0_Rb0_ISR
 void timer0_Rb0_ISR(void)
 {
  
     if (INTCONbits.TMR0IF==1) {
    
        count =0;
        LedRouge=!LedRouge;
        WriteTimer0(0);
        INTCONbits.TMR0IF = 0;
        INTCONbits.TMR0IE = 1;
     }
      if (INTCONbits.INT0IF==1) {      
       // if there is falling edge then read rc5
        count ++;
        INTCONbits.INT0IF = 0;
        INTCONbits.INT0IE = 1;
     }
}
 
 
 
 
 
 
 
 
//------  EEPROM du PIC ---------------

unsigned char EEPROM_Lect(unsigned char adrL) // lecture a l'adresse adrL
{
	EEADR=adrL;
	EECON1bits.EEPGD=0;     // 0= adressage EEPROM
	EECON1bits.CFGS=0;      // 0= acces data EEPROM
	EECON1bits.RD=1;        // arme Lecture EEprom
	 Tempo(500L);
	return(EEDATA);
}

void EEPROM_Ecr(unsigned char adrE,unsigned char car) // ecrit  a l'adresse adrE
{
	EEADR= adrE;
	EEDATA=car;
	EECON1bits.EEPGD=0;
	EECON1bits.WREN=1;            // autorise ecriture EEPROM
	EECON2=0x55;
	EECON2=0xAA;
	EECON1bits.WR=1;
	while (PIR2bits.EEIF==0);
	PIR2bits.EEIF=0;
	EECON1bits.WREN=0;
}

void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char *ptr1)
{
	while (*ptr1) EEPROM_Ecr(adrx++,*ptr1++);
}


void PrintOut_Eeprom_Msg(int PtrE)
{ int i;
  do
  {
  i = (int)EEPROM_Lect(PtrE);
  if ( i==0) break;

  Put_RS((Byte)i);
  PtrE++;
  if ( PtrE > 255) break;
   }
  while (i!=0)  ;
 Tempo(15000L);
}

void Write_Word(unsigned int M)     // entier cadre sur 5 digits complet par des zeros a gauche
{
 unsigned int k,L;
 valtxt=&Entree[0];
 itoa(M,valtxt);
 k=strlen(valtxt);
 for (L=k;L<4;L++) Put_RS('0');
 k=PutStr_RS(valtxt);
}

void Decompile_byte(Byte un) {
Byte masque;
  masque = 0x80;
  while (masque > 0u )
 {
  if (un & masque)
      Put_RS(49u);  //  '1'
    else
      Put_RS(48u);  //  '0'
      
    masque =masque >>1;
     }
}

void Octet2Hex(unsigned char number)
{
char high,low;
  // high nibble
  high = ((number & 0xF0) >> 4) + 48; // + '0'
  if (high > '9')
    high =high + 7;
 // low nibble
  low = (number & 0x0F) + 48;          // +'0' low nibble
  if (low > '9')                       // '9'= 57u
    low += 7;                         // > '9'
  Put_RS(high);
  Put_RS(low);
  Put_RS('h');
 }

void CRLF()
{
  Put_RS(CR);  Put_RS(LF);
  }

void Tempo(long val)
{
while(val>0){val--;}
}


void Remplis_N_blancs(Byte N)
{int i;
 for (i=0;i<N;i++)
 {
  Put_RS(' ');
 }
}      
      

void Init_Hardware() {
   PORTB = 0xFF;
   TRISB = 0b11111101;   // config portb pins
  /*
   TRISBbits.TRISB0=1;   	// B0 <- IR input
   TRISBbits.TRISB1=0;   	// B1 --> Led Blanche
   TRISBbits.TRISB2=1;   	// B2 not used
   TRISBbits.TRISB3=1;		// B3 not used 
   TRISBbits.TRISB4=1;		// B4 not used
   TRISBbits.TRISB5=1;		// B5 not used	
   TRISBbits.TRISB6=1;       //  B6 not used
   TRISBbits.TRISB7=1;       //  B7 not used             
  */
  PORTA = 0x00;
  LATA=0x00;
  // ATTENTION a l'ordre des canaux ANALOGIQUES !!!
  TRISA = 0b00101111 ;  // PORTA is RA0,1,2,3,5= Digital input  RA4=Digital output
  ADCON1 = 0b10000010 ; // portA RA0,RA1,RA2,RA3,RA5=Analog,  RA4=Digital, 5V=+ref
                        //       Ch0,Ch1,Ch2,CH3,Ch4
  ADCON0 =1 ;
  PORTC = 0xFF;          // set PORTC to $FF
  TRISC = 0b10000000;    // all output expect RC7
  TRISCbits.TRISC7 = 1;  // RX - Set Receive pin for UART RS232 and Bootloader
  TRISCbits.TRISC6 = 0;  // TX - Set as Output UART RS232 and Bootloader 
 }

//**************************
//           MAIN
//**************************
 void main()
 {
 Tempo(15000L);
 Init_Hardware() ;
 LedBlanc=ON;
 LedRouge=OFF;
 
  // init des pointeurs stockage reception car
 ptecr=buffer; 
 ptlec= ptecr;
 txt=&Texte[0];
 valtxt=&Entree[0];
 
 Init_RS();		//19200 bauds
 Put_RS(CLS);
 Tempo(10000L);  // laisser un peu de temp pour l'effacement ecran Terminal VBray
 CRLF();
 
  k=PutStr_RS(txt);
  CRLF();
 
 strcpypgm2ram(&Texte[0],Menu_Str[12]);
 k=PutStr_RS(Texte);
  
 PrintOut_Eeprom_Msg(0);      // init RS
 PrintOut_Eeprom_Msg(0x60);
 PrintOut_Eeprom_Msg(0x80);
 PrintOut_Eeprom_Msg(0xA0);
 PrintOut_Eeprom_Msg(0xC0);
 PrintOut_Eeprom_Msg(0xE0);
 CRLF();
 LedBlanc=OFF;
 LedRouge=ON;
 Tempo(20000L);
 
 strcpypgm2ram(&Texte[0],Menu_Str[1]);
 k=PutStr_RS(Texte);
 CRLF();
 Tempo(10000L);

  //On initialise ADC10b du PIC
 OpenADC( ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_8ANA_0REF,ADC_CH0 &ADC_INT_OFF );
 strcpypgm2ram(&Texte[0],Menu_Str[8]);
 k=PutStr_RS(Texte);
 CRLF();
 Tempo(10000L);
  
 NbMes=0;
 do
 {   
  if (ptlec != ptecr) 
  {
       receive =Get_RS();
      Put_RS('E');  Put_RS('='); 
      M=(int)receive;
      Write_Word(M);
      CRLF();
  } 

 Put_RS('#');
 Write_Word(NbMes);
 Put_RS(TAB);
 Tempo(5000L);
   
 //------- 5x   Analogues 10 bits------
 for (j=0;j<5;j++)
 {  
  SetChanADC( j );
  Delay10TCYx( 10 ); // Delay for 100TCY
  ConvertADC(); // Start conversion
  while( BusyADC() );
  M = ReadADC(); // Read result
  Put_RS('A');Put_RS(j+48);Put_RS('=');
   Tempo(1000L);
   Write_Word(M);
  Put_RS(';');
    }

//------- IR capture
   CRLF();
   strcpypgm2ram(&Texte[0],Menu_Str[11]);
   k=PutStr_RS(Texte);
   CRLF();
   Tempo(10000L);

   RC5Len= rc5_init(); // Attention rc5 init avec Q=10Mhz
   M= RC5Len;
   Write_Word(M);
   CRLF();
   M1=0;
   T0CONbits.T08BIT=0;  //mode 16bits
   T0CON=0b00000000;     //prescaler=1/2
   while (1) 
   {
   if(PORTBbits.RB0==0) 
   {
   WriteTimer0(0);
   T0CONbits.TMR0ON=1;
   while(PORTBbits.RB0==0); 
   M1=ReadTimer0() ;
   T0CONbits.TMR0ON=0;
   }
   if (M1>0)
    {
    itoa(M1,&Texte[0]);
    k=PutStr_RS(Texte);
      CRLF();
      M1=0;
    }  
   }   
  NbMes++;
  CRLF(); 
  Tempo(25000L);
  LedBlanc=!LedBlanc;
 }while (1);
}
//-------------------   end of  Main --------------------

/*

PROJET: IRC5_18F252.mcp 

C18: IRC5_18F252_0411.c
Port Com 19200b & Init HARD....Usage I2c Software MPLAB C18  
18F252 avec bootloader        
paulfjujo@free.fr             
MPLAB IDE V8.63.............. 
MPLAB C18 v3.37.01 .........

.................
Init ADC10b PIC18F

#0000	A0=0195;A1=0194;A2=0195;A3=0195;A4=0195;
IR TSOP Capture= 

0024

//  touche <- telecommande
2326
2323
697
1225
657
276
183
2328
2323
724
*/